t: add a function to check executable bit
[git/debian.git] / t / test-lib-functions.sh
blob2ef579edf316b41be16188841e54fb3804b8a7f4
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
4 # Copyright (c) 2005 Junio C Hamano
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see http://www.gnu.org/licenses/ .
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
35 # Like test_set_editor but sets GIT_SEQUENCE_EDITOR instead of EDITOR
36 test_set_sequence_editor () {
37 FAKE_SEQUENCE_EDITOR="$1"
38 export FAKE_SEQUENCE_EDITOR
39 GIT_SEQUENCE_EDITOR='"$FAKE_SEQUENCE_EDITOR"'
40 export GIT_SEQUENCE_EDITOR
43 test_decode_color () {
44 awk '
45 function name(n) {
46 if (n == 0) return "RESET";
47 if (n == 1) return "BOLD";
48 if (n == 2) return "FAINT";
49 if (n == 3) return "ITALIC";
50 if (n == 7) return "REVERSE";
51 if (n == 30) return "BLACK";
52 if (n == 31) return "RED";
53 if (n == 32) return "GREEN";
54 if (n == 33) return "YELLOW";
55 if (n == 34) return "BLUE";
56 if (n == 35) return "MAGENTA";
57 if (n == 36) return "CYAN";
58 if (n == 37) return "WHITE";
59 if (n == 40) return "BLACK";
60 if (n == 41) return "BRED";
61 if (n == 42) return "BGREEN";
62 if (n == 43) return "BYELLOW";
63 if (n == 44) return "BBLUE";
64 if (n == 45) return "BMAGENTA";
65 if (n == 46) return "BCYAN";
66 if (n == 47) return "BWHITE";
69 while (match($0, /\033\[[0-9;]*m/) != 0) {
70 printf "%s<", substr($0, 1, RSTART-1);
71 codes = substr($0, RSTART+2, RLENGTH-3);
72 if (length(codes) == 0)
73 printf "%s", name(0)
74 else {
75 n = split(codes, ary, ";");
76 sep = "";
77 for (i = 1; i <= n; i++) {
78 printf "%s%s", sep, name(ary[i]);
79 sep = ";"
82 printf ">";
83 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
85 print
90 lf_to_nul () {
91 perl -pe 'y/\012/\000/'
94 nul_to_q () {
95 perl -pe 'y/\000/Q/'
98 q_to_nul () {
99 perl -pe 'y/Q/\000/'
102 q_to_cr () {
103 tr Q '\015'
106 q_to_tab () {
107 tr Q '\011'
110 qz_to_tab_space () {
111 tr QZ '\011\040'
114 append_cr () {
115 sed -e 's/$/Q/' | tr Q '\015'
118 remove_cr () {
119 tr '\015' Q | sed -e 's/Q$//'
122 # In some bourne shell implementations, the "unset" builtin returns
123 # nonzero status when a variable to be unset was not set in the first
124 # place.
126 # Use sane_unset when that should not be considered an error.
128 sane_unset () {
129 unset "$@"
130 return 0
133 test_tick () {
134 if test -z "${test_tick+set}"
135 then
136 test_tick=1112911993
137 else
138 test_tick=$(($test_tick + 60))
140 GIT_COMMITTER_DATE="$test_tick -0700"
141 GIT_AUTHOR_DATE="$test_tick -0700"
142 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
145 # Stop execution and start a shell. This is useful for debugging tests.
147 # Be sure to remove all invocations of this command before submitting.
148 # WARNING: the shell invoked by this helper does not have the same environment
149 # as the one running the tests (shell variables and functions are not
150 # available, and the options below further modify the environment). As such,
151 # commands copied from a test script might behave differently than when
152 # running the test.
154 # Usage: test_pause [options]
155 # -t
156 # Use your original TERM instead of test-lib.sh's "dumb".
157 # This usually restores color output in the invoked shell.
158 # -s
159 # Invoke $SHELL instead of $TEST_SHELL_PATH.
160 # -h
161 # Use your original HOME instead of test-lib.sh's "$TRASH_DIRECTORY".
162 # This allows you to use your regular shell environment and Git aliases.
163 # CAUTION: running commands copied from a test script into the paused shell
164 # might result in files in your HOME being overwritten.
165 # -a
166 # Shortcut for -t -s -h
168 test_pause () {
169 PAUSE_TERM=$TERM &&
170 PAUSE_SHELL=$TEST_SHELL_PATH &&
171 PAUSE_HOME=$HOME &&
172 while test $# != 0
174 case "$1" in
176 PAUSE_TERM="$USER_TERM"
179 PAUSE_SHELL="$SHELL"
182 PAUSE_HOME="$USER_HOME"
185 PAUSE_TERM="$USER_TERM"
186 PAUSE_SHELL="$SHELL"
187 PAUSE_HOME="$USER_HOME"
190 break
192 esac
193 shift
194 done &&
195 TERM="$PAUSE_TERM" HOME="$PAUSE_HOME" "$PAUSE_SHELL" <&6 >&5 2>&7
198 # Wrap git with a debugger. Adding this to a command can make it easier
199 # to understand what is going on in a failing test.
201 # Usage: debug [options] <git command>
202 # -d <debugger>
203 # --debugger=<debugger>
204 # Use <debugger> instead of GDB
205 # -t
206 # Use your original TERM instead of test-lib.sh's "dumb".
207 # This usually restores color output in the debugger.
208 # WARNING: the command being debugged might behave differently than when
209 # running the test.
211 # Examples:
212 # debug git checkout master
213 # debug --debugger=nemiver git $ARGS
214 # debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
215 debug () {
216 GIT_DEBUGGER=1 &&
217 DEBUG_TERM=$TERM &&
218 while test $# != 0
220 case "$1" in
222 DEBUG_TERM="$USER_TERM"
225 GIT_DEBUGGER="$2" &&
226 shift
228 --debugger=*)
229 GIT_DEBUGGER="${1#*=}"
232 break
234 esac
235 shift
236 done &&
238 dotfiles=".gdbinit .lldbinit"
240 for dotfile in $dotfiles
242 dotfile="$USER_HOME/$dotfile" &&
243 test -f "$dotfile" && cp "$dotfile" "$HOME" || :
244 done &&
246 TERM="$DEBUG_TERM" GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7 &&
248 for dotfile in $dotfiles
250 rm -f "$HOME/$dotfile"
251 done
254 # Usage: test_commit [options] <message> [<file> [<contents> [<tag>]]]
255 # -C <dir>:
256 # Run all git commands in directory <dir>
257 # --notick
258 # Do not call test_tick before making a commit
259 # --append
260 # Use ">>" instead of ">" when writing "<contents>" to "<file>"
261 # --printf
262 # Use "printf" instead of "echo" when writing "<contents>" to
263 # "<file>", use this to write escape sequences such as "\0", a
264 # trailing "\n" won't be added automatically. This option
265 # supports nothing but the FORMAT of printf(1), i.e. no custom
266 # ARGUMENT(s).
267 # --signoff
268 # Invoke "git commit" with --signoff
269 # --author <author>
270 # Invoke "git commit" with --author <author>
271 # --no-tag
272 # Do not tag the resulting commit
273 # --annotate
274 # Create an annotated tag with "--annotate -m <message>". Calls
275 # test_tick between making the commit and tag, unless --notick
276 # is given.
278 # This will commit a file with the given contents and the given commit
279 # message, and tag the resulting commit with the given tag name.
281 # <file>, <contents>, and <tag> all default to <message>.
283 test_commit () {
284 local notick= &&
285 local echo=echo &&
286 local append= &&
287 local author= &&
288 local signoff= &&
289 local indir= &&
290 local tag=light &&
291 while test $# != 0
293 case "$1" in
294 --notick)
295 notick=yes
297 --printf)
298 echo=printf
300 --append)
301 append=yes
303 --author)
304 author="$2"
305 shift
307 --signoff)
308 signoff="$1"
310 --date)
311 notick=yes
312 GIT_COMMITTER_DATE="$2"
313 GIT_AUTHOR_DATE="$2"
314 shift
317 indir="$2"
318 shift
320 --no-tag)
321 tag=none
323 --annotate)
324 tag=annotate
327 break
329 esac
330 shift
331 done &&
332 indir=${indir:+"$indir"/} &&
333 local file=${2:-"$1.t"} &&
334 if test -n "$append"
335 then
336 $echo "${3-$1}" >>"$indir$file"
337 else
338 $echo "${3-$1}" >"$indir$file"
339 fi &&
340 git ${indir:+ -C "$indir"} add -- "$file" &&
341 if test -z "$notick"
342 then
343 test_tick
344 fi &&
345 git ${indir:+ -C "$indir"} commit \
346 ${author:+ --author "$author"} \
347 $signoff -m "$1" &&
348 case "$tag" in
349 none)
351 light)
352 git ${indir:+ -C "$indir"} tag "${4:-$1}"
354 annotate)
355 if test -z "$notick"
356 then
357 test_tick
358 fi &&
359 git ${indir:+ -C "$indir"} tag -a -m "$1" "${4:-$1}"
361 esac
364 # Call test_merge with the arguments "<message> <commit>", where <commit>
365 # can be a tag pointing to the commit-to-merge.
367 test_merge () {
368 label="$1" &&
369 shift &&
370 test_tick &&
371 git merge -m "$label" "$@" &&
372 git tag "$label"
375 # Efficiently create <nr> commits, each with a unique number (from 1 to <nr>
376 # by default) in the commit message.
378 # Usage: test_commit_bulk [options] <nr>
379 # -C <dir>:
380 # Run all git commands in directory <dir>
381 # --ref=<n>:
382 # ref on which to create commits (default: HEAD)
383 # --start=<n>:
384 # number commit messages from <n> (default: 1)
385 # --message=<msg>:
386 # use <msg> as the commit mesasge (default: "commit %s")
387 # --filename=<fn>:
388 # modify <fn> in each commit (default: %s.t)
389 # --contents=<string>:
390 # place <string> in each file (default: "content %s")
391 # --id=<string>:
392 # shorthand to use <string> and %s in message, filename, and contents
394 # The message, filename, and contents strings are evaluated by printf, with the
395 # first "%s" replaced by the current commit number. So you can do:
397 # test_commit_bulk --filename=file --contents="modification %s"
399 # to have every commit touch the same file, but with unique content.
401 test_commit_bulk () {
402 tmpfile=.bulk-commit.input
403 indir=.
404 ref=HEAD
406 message='commit %s'
407 filename='%s.t'
408 contents='content %s'
409 while test $# -gt 0
411 case "$1" in
413 indir=$2
414 shift
416 --ref=*)
417 ref=${1#--*=}
419 --start=*)
420 n=${1#--*=}
422 --message=*)
423 message=${1#--*=}
425 --filename=*)
426 filename=${1#--*=}
428 --contents=*)
429 contents=${1#--*=}
431 --id=*)
432 message="${1#--*=} %s"
433 filename="${1#--*=}-%s.t"
434 contents="${1#--*=} %s"
437 BUG "invalid test_commit_bulk option: $1"
440 break
442 esac
443 shift
444 done
445 total=$1
447 add_from=
448 if git -C "$indir" rev-parse --quiet --verify "$ref"
449 then
450 add_from=t
453 while test "$total" -gt 0
455 test_tick &&
456 echo "commit $ref"
457 printf 'author %s <%s> %s\n' \
458 "$GIT_AUTHOR_NAME" \
459 "$GIT_AUTHOR_EMAIL" \
460 "$GIT_AUTHOR_DATE"
461 printf 'committer %s <%s> %s\n' \
462 "$GIT_COMMITTER_NAME" \
463 "$GIT_COMMITTER_EMAIL" \
464 "$GIT_COMMITTER_DATE"
465 echo "data <<EOF"
466 printf "$message\n" $n
467 echo "EOF"
468 if test -n "$add_from"
469 then
470 echo "from $ref^0"
471 add_from=
473 printf "M 644 inline $filename\n" $n
474 echo "data <<EOF"
475 printf "$contents\n" $n
476 echo "EOF"
477 echo
478 n=$((n + 1))
479 total=$((total - 1))
480 done >"$tmpfile"
482 git -C "$indir" \
483 -c fastimport.unpacklimit=0 \
484 fast-import <"$tmpfile" || return 1
486 # This will be left in place on failure, which may aid debugging.
487 rm -f "$tmpfile"
489 # If we updated HEAD, then be nice and update the index and working
490 # tree, too.
491 if test "$ref" = "HEAD"
492 then
493 git -C "$indir" checkout -f HEAD || return 1
498 # This function helps systems where core.filemode=false is set.
499 # Use it instead of plain 'chmod +x' to set or unset the executable bit
500 # of a file in the working directory and add it to the index.
502 test_chmod () {
503 chmod "$@" &&
504 git update-index --add "--chmod=$@"
507 # Get the modebits from a file or directory, ignoring the setgid bit (g+s).
508 # This bit is inherited by subdirectories at their creation. So we remove it
509 # from the returning string to prevent callers from having to worry about the
510 # state of the bit in the test directory.
512 test_modebits () {
513 ls -ld "$1" | sed -e 's|^\(..........\).*|\1|' \
514 -e 's|^\(......\)S|\1-|' -e 's|^\(......\)s|\1x|'
517 # Unset a configuration variable, but don't fail if it doesn't exist.
518 test_unconfig () {
519 config_dir=
520 if test "$1" = -C
521 then
522 shift
523 config_dir=$1
524 shift
526 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
527 config_status=$?
528 case "$config_status" in
529 5) # ok, nothing to unset
530 config_status=0
532 esac
533 return $config_status
536 # Set git config, automatically unsetting it after the test is over.
537 test_config () {
538 config_dir=
539 if test "$1" = -C
540 then
541 shift
542 config_dir=$1
543 shift
545 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
546 git ${config_dir:+-C "$config_dir"} config "$@"
549 test_config_global () {
550 test_when_finished "test_unconfig --global '$1'" &&
551 git config --global "$@"
554 write_script () {
556 echo "#!${2-"$SHELL_PATH"}" &&
558 } >"$1" &&
559 chmod +x "$1"
562 # Usage: test_hook [options] <hook-name> <<-\EOF
564 # -C <dir>:
565 # Run all git commands in directory <dir>
566 # --setup
567 # Setup a hook for subsequent tests, i.e. don't remove it in a
568 # "test_when_finished"
569 # --clobber
570 # Overwrite an existing <hook-name>, if it exists. Implies
571 # --setup (i.e. the "test_when_finished" is assumed to have been
572 # set up already).
573 # --disable
574 # Disable (chmod -x) an existing <hook-name>, which must exist.
575 # --remove
576 # Remove (rm -f) an existing <hook-name>, which must exist.
577 test_hook () {
578 setup= &&
579 clobber= &&
580 disable= &&
581 remove= &&
582 indir= &&
583 while test $# != 0
585 case "$1" in
587 indir="$2" &&
588 shift
590 --setup)
591 setup=t
593 --clobber)
594 clobber=t
596 --disable)
597 disable=t
599 --remove)
600 remove=t
603 BUG "invalid argument: $1"
606 break
608 esac &&
609 shift
610 done &&
612 git_dir=$(git -C "$indir" rev-parse --absolute-git-dir) &&
613 hook_dir="$git_dir/hooks" &&
614 hook_file="$hook_dir/$1" &&
615 if test -n "$disable$remove"
616 then
617 test_path_is_file "$hook_file" &&
618 if test -n "$disable"
619 then
620 chmod -x "$hook_file"
621 elif test -n "$remove"
622 then
623 rm -f "$hook_file"
624 fi &&
625 return 0
626 fi &&
627 if test -z "$clobber"
628 then
629 test_path_is_missing "$hook_file"
630 fi &&
631 if test -z "$setup$clobber"
632 then
633 test_when_finished "rm \"$hook_file\""
634 fi &&
635 write_script "$hook_file"
638 # Use test_set_prereq to tell that a particular prerequisite is available.
639 # The prerequisite can later be checked for in two ways:
641 # - Explicitly using test_have_prereq.
643 # - Implicitly by specifying the prerequisite tag in the calls to
644 # test_expect_{success,failure}
646 # The single parameter is the prerequisite tag (a simple word, in all
647 # capital letters by convention).
649 test_unset_prereq () {
650 ! test_have_prereq "$1" ||
651 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
654 test_set_prereq () {
655 if test -n "$GIT_TEST_FAIL_PREREQS_INTERNAL"
656 then
657 case "$1" in
658 # The "!" case is handled below with
659 # test_unset_prereq()
662 # List of things we can't easily pretend to not support
663 SYMLINKS)
665 # Inspecting whether GIT_TEST_FAIL_PREREQS is on
666 # should be unaffected.
667 FAIL_PREREQS)
670 return
671 esac
674 case "$1" in
676 test_unset_prereq "${1#!}"
679 satisfied_prereq="$satisfied_prereq$1 "
681 esac
683 satisfied_prereq=" "
684 lazily_testable_prereq= lazily_tested_prereq=
686 # Usage: test_lazy_prereq PREREQ 'script'
687 test_lazy_prereq () {
688 lazily_testable_prereq="$lazily_testable_prereq$1 "
689 eval test_prereq_lazily_$1=\$2
692 test_run_lazy_prereq_ () {
693 script='
694 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&
696 cd "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&'"$2"'
698 say >&3 "checking prerequisite: $1"
699 say >&3 "$script"
700 test_eval_ "$script"
701 eval_ret=$?
702 rm -rf "$TRASH_DIRECTORY/prereq-test-dir-$1"
703 if test "$eval_ret" = 0; then
704 say >&3 "prerequisite $1 ok"
705 else
706 say >&3 "prerequisite $1 not satisfied"
708 return $eval_ret
711 test_have_prereq () {
712 # prerequisites can be concatenated with ','
713 save_IFS=$IFS
714 IFS=,
715 set -- $*
716 IFS=$save_IFS
718 total_prereq=0
719 ok_prereq=0
720 missing_prereq=
722 for prerequisite
724 case "$prerequisite" in
726 negative_prereq=t
727 prerequisite=${prerequisite#!}
730 negative_prereq=
731 esac
733 case " $lazily_tested_prereq " in
734 *" $prerequisite "*)
737 case " $lazily_testable_prereq " in
738 *" $prerequisite "*)
739 eval "script=\$test_prereq_lazily_$prerequisite" &&
740 if test_run_lazy_prereq_ "$prerequisite" "$script"
741 then
742 test_set_prereq $prerequisite
744 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
745 esac
747 esac
749 total_prereq=$(($total_prereq + 1))
750 case "$satisfied_prereq" in
751 *" $prerequisite "*)
752 satisfied_this_prereq=t
755 satisfied_this_prereq=
756 esac
758 case "$satisfied_this_prereq,$negative_prereq" in
759 t,|,t)
760 ok_prereq=$(($ok_prereq + 1))
763 # Keep a list of missing prerequisites; restore
764 # the negative marker if necessary.
765 prerequisite=${negative_prereq:+!}$prerequisite
767 # Abort if this prereq was marked as required
768 if test -n "$GIT_TEST_REQUIRE_PREREQ"
769 then
770 case " $GIT_TEST_REQUIRE_PREREQ " in
771 *" $prerequisite "*)
772 BAIL_OUT "required prereq $prerequisite failed"
774 esac
777 if test -z "$missing_prereq"
778 then
779 missing_prereq=$prerequisite
780 else
781 missing_prereq="$prerequisite,$missing_prereq"
783 esac
784 done
786 test $total_prereq = $ok_prereq
789 test_declared_prereq () {
790 case ",$test_prereq," in
791 *,$1,*)
792 return 0
794 esac
795 return 1
798 test_verify_prereq () {
799 test -z "$test_prereq" ||
800 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
801 BUG "'$test_prereq' does not look like a prereq"
804 test_expect_failure () {
805 test_start_ "$@"
806 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
807 test "$#" = 2 ||
808 BUG "not 2 or 3 parameters to test-expect-failure"
809 test_verify_prereq
810 export test_prereq
811 if ! test_skip "$@"
812 then
813 test -n "$test_skip_test_preamble" ||
814 say >&3 "checking known breakage of $TEST_NUMBER.$test_count '$1': $2"
815 if test_run_ "$2" expecting_failure
816 then
817 test_known_broken_ok_ "$1"
818 else
819 test_known_broken_failure_ "$1"
822 test_finish_
825 test_expect_success () {
826 test_start_ "$@"
827 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
828 test "$#" = 2 ||
829 BUG "not 2 or 3 parameters to test-expect-success"
830 test_verify_prereq
831 export test_prereq
832 if ! test_skip "$@"
833 then
834 test -n "$test_skip_test_preamble" ||
835 say >&3 "expecting success of $TEST_NUMBER.$test_count '$1': $2"
836 if test_run_ "$2"
837 then
838 test_ok_ "$1"
839 else
840 test_failure_ "$@"
843 test_finish_
846 # debugging-friendly alternatives to "test [-f|-d|-e]"
847 # The commands test the existence or non-existence of $1
848 test_path_is_file () {
849 test "$#" -ne 1 && BUG "1 param"
850 if ! test -f "$1"
851 then
852 echo "File $1 doesn't exist"
853 false
857 test_path_is_file_not_symlink () {
858 test "$#" -ne 1 && BUG "1 param"
859 test_path_is_file "$1" &&
860 if test -h "$1"
861 then
862 echo "$1 shouldn't be a symbolic link"
863 false
867 test_path_is_dir () {
868 test "$#" -ne 1 && BUG "1 param"
869 if ! test -d "$1"
870 then
871 echo "Directory $1 doesn't exist"
872 false
876 test_path_is_dir_not_symlink () {
877 test "$#" -ne 1 && BUG "1 param"
878 test_path_is_dir "$1" &&
879 if test -h "$1"
880 then
881 echo "$1 shouldn't be a symbolic link"
882 false
886 test_path_exists () {
887 test "$#" -ne 1 && BUG "1 param"
888 if ! test -e "$1"
889 then
890 echo "Path $1 doesn't exist"
891 false
895 test_path_is_symlink () {
896 test "$#" -ne 1 && BUG "1 param"
897 if ! test -h "$1"
898 then
899 echo "Symbolic link $1 doesn't exist"
900 false
904 test_path_is_executable () {
905 test "$#" -ne 1 && BUG "1 param"
906 if ! test -x "$1"
907 then
908 echo "$1 is not executable"
909 false
913 # Check if the directory exists and is empty as expected, barf otherwise.
914 test_dir_is_empty () {
915 test "$#" -ne 1 && BUG "1 param"
916 test_path_is_dir "$1" &&
917 if test -n "$(ls -a1 "$1" | grep -E -v '^\.\.?$')"
918 then
919 echo "Directory '$1' is not empty, it contains:"
920 ls -la "$1"
921 return 1
925 # Check if the file exists and has a size greater than zero
926 test_file_not_empty () {
927 test "$#" = 2 && BUG "2 param"
928 if ! test -s "$1"
929 then
930 echo "'$1' is not a non-empty file."
931 false
935 test_path_is_missing () {
936 test "$#" -ne 1 && BUG "1 param"
937 if test -e "$1"
938 then
939 echo "Path exists:"
940 ls -ld "$1"
941 false
945 # test_line_count checks that a file has the number of lines it
946 # ought to. For example:
948 # test_expect_success 'produce exactly one line of output' '
949 # do something >output &&
950 # test_line_count = 1 output
953 # is like "test $(wc -l <output) = 1" except that it passes the
954 # output through when the number of lines is wrong.
956 test_line_count () {
957 if test $# != 3
958 then
959 BUG "not 3 parameters to test_line_count"
960 elif ! test $(wc -l <"$3") "$1" "$2"
961 then
962 echo "test_line_count: line count for $3 !$1 $2"
963 cat "$3"
964 return 1
968 # SYNOPSIS:
969 # test_stdout_line_count <bin-ops> <value> <cmd> [<args>...]
971 # test_stdout_line_count checks that the output of a command has the number
972 # of lines it ought to. For example:
974 # test_stdout_line_count = 3 git ls-files -u
975 # test_stdout_line_count -gt 10 ls
976 test_stdout_line_count () {
977 local ops val trashdir &&
978 if test "$#" -le 3
979 then
980 BUG "expect 3 or more arguments"
981 fi &&
982 ops="$1" &&
983 val="$2" &&
984 shift 2 &&
985 if ! trashdir="$(git rev-parse --git-dir)/trash"; then
986 BUG "expect to be run inside a worktree"
987 fi &&
988 mkdir -p "$trashdir" &&
989 "$@" >"$trashdir/output" &&
990 test_line_count "$ops" "$val" "$trashdir/output"
994 test_file_size () {
995 test "$#" -ne 1 && BUG "1 param"
996 test-tool path-utils file-size "$1"
999 # Returns success if a comma separated string of keywords ($1) contains a
1000 # given keyword ($2).
1001 # Examples:
1002 # `list_contains "foo,bar" bar` returns 0
1003 # `list_contains "foo" bar` returns 1
1005 list_contains () {
1006 case ",$1," in
1007 *,$2,*)
1008 return 0
1010 esac
1011 return 1
1014 # Returns success if the arguments indicate that a command should be
1015 # accepted by test_must_fail(). If the command is run with env, the env
1016 # and its corresponding variable settings will be stripped before we
1017 # test the command being run.
1018 test_must_fail_acceptable () {
1019 if test "$1" = "env"
1020 then
1021 shift
1022 while test $# -gt 0
1024 case "$1" in
1025 *?=*)
1026 shift
1029 break
1031 esac
1032 done
1035 case "$1" in
1036 git|__git*|scalar|test-tool|test_terminal)
1037 return 0
1040 return 1
1042 esac
1045 # This is not among top-level (test_expect_success | test_expect_failure)
1046 # but is a prefix that can be used in the test script, like:
1048 # test_expect_success 'complain and die' '
1049 # do something &&
1050 # do something else &&
1051 # test_must_fail git checkout ../outerspace
1054 # Writing this as "! git checkout ../outerspace" is wrong, because
1055 # the failure could be due to a segv. We want a controlled failure.
1057 # Accepts the following options:
1059 # ok=<signal-name>[,<...>]:
1060 # Don't treat an exit caused by the given signal as error.
1061 # Multiple signals can be specified as a comma separated list.
1062 # Currently recognized signal names are: sigpipe, success.
1063 # (Don't use 'success', use 'test_might_fail' instead.)
1065 # Do not use this to run anything but "git" and other specific testable
1066 # commands (see test_must_fail_acceptable()). We are not in the
1067 # business of vetting system supplied commands -- in other words, this
1068 # is wrong:
1070 # test_must_fail grep pattern output
1072 # Instead use '!':
1074 # ! grep pattern output
1076 test_must_fail () {
1077 case "$1" in
1078 ok=*)
1079 _test_ok=${1#ok=}
1080 shift
1083 _test_ok=
1085 esac
1086 if ! test_must_fail_acceptable "$@"
1087 then
1088 echo >&7 "test_must_fail: only 'git' is allowed: $*"
1089 return 1
1091 "$@" 2>&7
1092 exit_code=$?
1093 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
1094 then
1095 echo >&4 "test_must_fail: command succeeded: $*"
1096 return 1
1097 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
1098 then
1099 return 0
1100 elif test $exit_code -gt 129 && test $exit_code -le 192
1101 then
1102 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
1103 return 1
1104 elif test $exit_code -eq 127
1105 then
1106 echo >&4 "test_must_fail: command not found: $*"
1107 return 1
1108 elif test $exit_code -eq 126
1109 then
1110 echo >&4 "test_must_fail: valgrind error: $*"
1111 return 1
1113 return 0
1114 } 7>&2 2>&4
1116 # Similar to test_must_fail, but tolerates success, too. This is
1117 # meant to be used in contexts like:
1119 # test_expect_success 'some command works without configuration' '
1120 # test_might_fail git config --unset all.configuration &&
1121 # do something
1124 # Writing "git config --unset all.configuration || :" would be wrong,
1125 # because we want to notice if it fails due to segv.
1127 # Accepts the same options as test_must_fail.
1129 test_might_fail () {
1130 test_must_fail ok=success "$@" 2>&7
1131 } 7>&2 2>&4
1133 # Similar to test_must_fail and test_might_fail, but check that a
1134 # given command exited with a given exit code. Meant to be used as:
1136 # test_expect_success 'Merge with d/f conflicts' '
1137 # test_expect_code 1 git merge "merge msg" B master
1140 test_expect_code () {
1141 want_code=$1
1142 shift
1143 "$@" 2>&7
1144 exit_code=$?
1145 if test $exit_code = $want_code
1146 then
1147 return 0
1150 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
1151 return 1
1152 } 7>&2 2>&4
1154 # test_cmp is a helper function to compare actual and expected output.
1155 # You can use it like:
1157 # test_expect_success 'foo works' '
1158 # echo expected >expected &&
1159 # foo >actual &&
1160 # test_cmp expected actual
1163 # This could be written as either "cmp" or "diff -u", but:
1164 # - cmp's output is not nearly as easy to read as diff -u
1165 # - not all diff versions understand "-u"
1167 test_cmp () {
1168 test "$#" -ne 2 && BUG "2 param"
1169 eval "$GIT_TEST_CMP" '"$@"'
1172 # Check that the given config key has the expected value.
1174 # test_cmp_config [-C <dir>] <expected-value>
1175 # [<git-config-options>...] <config-key>
1177 # for example to check that the value of core.bar is foo
1179 # test_cmp_config foo core.bar
1181 test_cmp_config () {
1182 local GD &&
1183 if test "$1" = "-C"
1184 then
1185 shift &&
1186 GD="-C $1" &&
1187 shift
1188 fi &&
1189 printf "%s\n" "$1" >expect.config &&
1190 shift &&
1191 git $GD config "$@" >actual.config &&
1192 test_cmp expect.config actual.config
1195 # test_cmp_bin - helper to compare binary files
1197 test_cmp_bin () {
1198 test "$#" -ne 2 && BUG "2 param"
1199 cmp "$@"
1202 # Wrapper for grep which used to be used for
1203 # GIT_TEST_GETTEXT_POISON=false. Only here as a shim for other
1204 # in-flight changes. Should not be used and will be removed soon.
1205 test_i18ngrep () {
1206 eval "last_arg=\${$#}"
1208 test -f "$last_arg" ||
1209 BUG "test_i18ngrep requires a file to read as the last parameter"
1211 if test $# -lt 2 ||
1212 { test "x!" = "x$1" && test $# -lt 3 ; }
1213 then
1214 BUG "too few parameters to test_i18ngrep"
1217 if test "x!" = "x$1"
1218 then
1219 shift
1220 ! grep "$@" && return 0
1222 echo >&4 "error: '! grep $@' did find a match in:"
1223 else
1224 grep "$@" && return 0
1226 echo >&4 "error: 'grep $@' didn't find a match in:"
1229 if test -s "$last_arg"
1230 then
1231 cat >&4 "$last_arg"
1232 else
1233 echo >&4 "<File '$last_arg' is empty>"
1236 return 1
1239 # Check if the file expected to be empty is indeed empty, and barfs
1240 # otherwise.
1242 test_must_be_empty () {
1243 test "$#" -ne 1 && BUG "1 param"
1244 test_path_is_file "$1" &&
1245 if test -s "$1"
1246 then
1247 echo "'$1' is not empty, it contains:"
1248 cat "$1"
1249 return 1
1253 # Tests that its two parameters refer to the same revision, or if '!' is
1254 # provided first, that its other two parameters refer to different
1255 # revisions.
1256 test_cmp_rev () {
1257 local op='=' wrong_result=different
1259 if test $# -ge 1 && test "x$1" = 'x!'
1260 then
1261 op='!='
1262 wrong_result='the same'
1263 shift
1265 if test $# != 2
1266 then
1267 BUG "test_cmp_rev requires two revisions, but got $#"
1268 else
1269 local r1 r2
1270 r1=$(git rev-parse --verify "$1") &&
1271 r2=$(git rev-parse --verify "$2") || return 1
1273 if ! test "$r1" "$op" "$r2"
1274 then
1275 cat >&4 <<-EOF
1276 error: two revisions point to $wrong_result objects:
1277 '$1': $r1
1278 '$2': $r2
1280 return 1
1285 # Compare paths respecting core.ignoreCase
1286 test_cmp_fspath () {
1287 if test "x$1" = "x$2"
1288 then
1289 return 0
1292 if test true != "$(git config --get --type=bool core.ignorecase)"
1293 then
1294 return 1
1297 test "x$(echo "$1" | tr A-Z a-z)" = "x$(echo "$2" | tr A-Z a-z)"
1300 # Print a sequence of integers in increasing order, either with
1301 # two arguments (start and end):
1303 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
1305 # or with one argument (end), in which case it starts counting
1306 # from 1.
1308 test_seq () {
1309 case $# in
1310 1) set 1 "$@" ;;
1311 2) ;;
1312 *) BUG "not 1 or 2 parameters to test_seq" ;;
1313 esac
1314 test_seq_counter__=$1
1315 while test "$test_seq_counter__" -le "$2"
1317 echo "$test_seq_counter__"
1318 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
1319 done
1322 # This function can be used to schedule some commands to be run
1323 # unconditionally at the end of the test to restore sanity:
1325 # test_expect_success 'test core.capslock' '
1326 # git config core.capslock true &&
1327 # test_when_finished "git config --unset core.capslock" &&
1328 # hello world
1331 # That would be roughly equivalent to
1333 # test_expect_success 'test core.capslock' '
1334 # git config core.capslock true &&
1335 # hello world
1336 # git config --unset core.capslock
1339 # except that the greeting and config --unset must both succeed for
1340 # the test to pass.
1342 # Note that under --immediate mode, no clean-up is done to help diagnose
1343 # what went wrong.
1345 test_when_finished () {
1346 # We cannot detect when we are in a subshell in general, but by
1347 # doing so on Bash is better than nothing (the test will
1348 # silently pass on other shells).
1349 test "${BASH_SUBSHELL-0}" = 0 ||
1350 BUG "test_when_finished does nothing in a subshell"
1351 test_cleanup="{ $*
1352 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1355 # This function can be used to schedule some commands to be run
1356 # unconditionally at the end of the test script, e.g. to stop a daemon:
1358 # test_expect_success 'test git daemon' '
1359 # git daemon &
1360 # daemon_pid=$! &&
1361 # test_atexit 'kill $daemon_pid' &&
1362 # hello world
1365 # The commands will be executed before the trash directory is removed,
1366 # i.e. the atexit commands will still be able to access any pidfiles or
1367 # socket files.
1369 # Note that these commands will be run even when a test script run
1370 # with '--immediate' fails. Be careful with your atexit commands to
1371 # minimize any changes to the failed state.
1373 test_atexit () {
1374 # We cannot detect when we are in a subshell in general, but by
1375 # doing so on Bash is better than nothing (the test will
1376 # silently pass on other shells).
1377 test "${BASH_SUBSHELL-0}" = 0 ||
1378 BUG "test_atexit does nothing in a subshell"
1379 test_atexit_cleanup="{ $*
1380 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
1383 # Deprecated wrapper for "git init", use "git init" directly instead
1384 # Usage: test_create_repo <directory>
1385 test_create_repo () {
1386 git init "$@"
1389 # This function helps on symlink challenged file systems when it is not
1390 # important that the file system entry is a symbolic link.
1391 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
1392 # symbolic link entry y to the index.
1394 test_ln_s_add () {
1395 if test_have_prereq SYMLINKS
1396 then
1397 ln -s "$1" "$2" &&
1398 git update-index --add "$2"
1399 else
1400 printf '%s' "$1" >"$2" &&
1401 ln_s_obj=$(git hash-object -w "$2") &&
1402 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1403 # pick up stat info from the file
1404 git update-index "$2"
1408 # This function writes out its parameters, one per line
1409 test_write_lines () {
1410 printf "%s\n" "$@"
1413 perl () {
1414 command "$PERL_PATH" "$@" 2>&7
1415 } 7>&2 2>&4
1417 # Given the name of an environment variable with a bool value, normalize
1418 # its value to a 0 (true) or 1 (false or empty string) return code.
1420 # test_bool_env GIT_TEST_HTTPD <default-value>
1422 # Return with code corresponding to the given default value if the variable
1423 # is unset.
1424 # Abort the test script if either the value of the variable or the default
1425 # are not valid bool values.
1427 test_bool_env () {
1428 if test $# != 2
1429 then
1430 BUG "test_bool_env requires two parameters (variable name and default value)"
1433 test-tool env-helper --type=bool --default="$2" --exit-code "$1"
1434 ret=$?
1435 case $ret in
1436 0|1) # unset or valid bool value
1438 *) # invalid bool value or something unexpected
1439 error >&7 "test_bool_env requires bool values both for \$$1 and for the default fallback"
1441 esac
1442 return $ret
1445 # Exit the test suite, either by skipping all remaining tests or by
1446 # exiting with an error. If our prerequisite variable $1 falls back
1447 # on a default assume we were opportunistically trying to set up some
1448 # tests and we skip. If it is explicitly "true", then we report a failure.
1450 # The error/skip message should be given by $2.
1452 test_skip_or_die () {
1453 if ! test_bool_env "$1" false
1454 then
1455 skip_all=$2
1456 test_done
1458 error "$2"
1461 # Like "env FOO=BAR some-program", but run inside a subshell, which means
1462 # it also works for shell functions (though those functions cannot impact
1463 # the environment outside of the test_env invocation).
1464 test_env () {
1466 while test $# -gt 0
1468 case "$1" in
1469 *=*)
1470 eval "${1%%=*}=\${1#*=}"
1471 eval "export ${1%%=*}"
1472 shift
1475 "$@" 2>&7
1476 exit
1478 esac
1479 done
1481 } 7>&2 2>&4
1483 # Returns true if the numeric exit code in "$2" represents the expected signal
1484 # in "$1". Signals should be given numerically.
1485 test_match_signal () {
1486 if test "$2" = "$((128 + $1))"
1487 then
1488 # POSIX
1489 return 0
1490 elif test "$2" = "$((256 + $1))"
1491 then
1492 # ksh
1493 return 0
1495 return 1
1498 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1499 test_copy_bytes () {
1500 perl -e '
1501 my $len = $ARGV[1];
1502 while ($len > 0) {
1503 my $s;
1504 my $nread = sysread(STDIN, $s, $len);
1505 die "cannot read: $!" unless defined($nread);
1506 last unless $nread;
1507 print $s;
1508 $len -= $nread;
1510 ' - "$1"
1513 # run "$@" inside a non-git directory
1514 nongit () {
1515 test -d non-repo ||
1516 mkdir non-repo ||
1517 return 1
1520 GIT_CEILING_DIRECTORIES=$(pwd) &&
1521 export GIT_CEILING_DIRECTORIES &&
1522 cd non-repo &&
1523 "$@" 2>&7
1525 } 7>&2 2>&4
1527 # These functions are historical wrappers around "test-tool pkt-line"
1528 # for older tests. Use "test-tool pkt-line" itself in new tests.
1529 packetize () {
1530 if test $# -gt 0
1531 then
1532 packet="$*"
1533 printf '%04x%s' "$((4 + ${#packet}))" "$packet"
1534 else
1535 test-tool pkt-line pack
1539 packetize_raw () {
1540 test-tool pkt-line pack-raw-stdin
1543 depacketize () {
1544 test-tool pkt-line unpack
1547 # Converts base-16 data into base-8. The output is given as a sequence of
1548 # escaped octals, suitable for consumption by 'printf'.
1549 hex2oct () {
1550 perl -ne 'printf "\\%03o", hex for /../g'
1553 # Set the hash algorithm in use to $1. Only useful when testing the testsuite.
1554 test_set_hash () {
1555 test_hash_algo="$1"
1558 # Detect the hash algorithm in use.
1559 test_detect_hash () {
1560 test_hash_algo="${GIT_TEST_DEFAULT_HASH:-sha1}"
1563 # Load common hash metadata and common placeholder object IDs for use with
1564 # test_oid.
1565 test_oid_init () {
1566 test -n "$test_hash_algo" || test_detect_hash &&
1567 test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1568 test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1571 # Load key-value pairs from stdin suitable for use with test_oid. Blank lines
1572 # and lines starting with "#" are ignored. Keys must be shell identifier
1573 # characters.
1575 # Examples:
1576 # rawsz sha1:20
1577 # rawsz sha256:32
1578 test_oid_cache () {
1579 local tag rest k v &&
1581 { test -n "$test_hash_algo" || test_detect_hash; } &&
1582 while read tag rest
1584 case $tag in
1585 \#*)
1586 continue;;
1588 # non-empty
1591 # blank line
1592 continue;;
1593 esac &&
1595 k="${rest%:*}" &&
1596 v="${rest#*:}" &&
1598 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1599 then
1600 BUG 'bad hash algorithm'
1601 fi &&
1602 eval "test_oid_${k}_$tag=\"\$v\""
1603 done
1606 # Look up a per-hash value based on a key ($1). The value must have been loaded
1607 # by test_oid_init or test_oid_cache.
1608 test_oid () {
1609 local algo="${test_hash_algo}" &&
1611 case "$1" in
1612 --hash=*)
1613 algo="${1#--hash=}" &&
1614 shift;;
1617 esac &&
1619 local var="test_oid_${algo}_$1" &&
1621 # If the variable is unset, we must be missing an entry for this
1622 # key-hash pair, so exit with an error.
1623 if eval "test -z \"\${$var+set}\""
1624 then
1625 BUG "undefined key '$1'"
1626 fi &&
1627 eval "printf '%s\n' \"\${$var}\""
1630 # Insert a slash into an object ID so it can be used to reference a location
1631 # under ".git/objects". For example, "deadbeef..." becomes "de/adbeef..".
1632 test_oid_to_path () {
1633 local basename=${1#??}
1634 echo "${1%$basename}/$basename"
1637 # Parse oids from git ls-files --staged output
1638 test_parse_ls_files_stage_oids () {
1639 awk '{print $2}' -
1642 # Parse oids from git ls-tree output
1643 test_parse_ls_tree_oids () {
1644 awk '{print $3}' -
1647 # Choose a port number based on the test script's number and store it in
1648 # the given variable name, unless that variable already contains a number.
1649 test_set_port () {
1650 local var=$1 port
1652 if test $# -ne 1 || test -z "$var"
1653 then
1654 BUG "test_set_port requires a variable name"
1657 eval port=\$$var
1658 case "$port" in
1660 # No port is set in the given env var, use the test
1661 # number as port number instead.
1662 # Remove not only the leading 't', but all leading zeros
1663 # as well, so the arithmetic below won't (mis)interpret
1664 # a test number like '0123' as an octal value.
1665 port=${this_test#${this_test%%[1-9]*}}
1666 if test "${port:-0}" -lt 1024
1667 then
1668 # root-only port, use a larger one instead.
1669 port=$(($port + 10000))
1672 *[!0-9]*|0*)
1673 error >&7 "invalid port number: $port"
1676 # The user has specified the port.
1678 esac
1680 # Make sure that parallel '--stress' test jobs get different
1681 # ports.
1682 port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1683 eval $var=$port
1686 # Tests for the hidden file attribute on Windows
1687 test_path_is_hidden () {
1688 test_have_prereq MINGW ||
1689 BUG "test_path_is_hidden can only be used on Windows"
1691 # Use the output of `attrib`, ignore the absolute path
1692 case "$("$SYSTEMROOT"/system32/attrib "$1")" in *H*?:*) return 0;; esac
1693 return 1
1696 # Poor man's URI escaping. Good enough for the test suite whose trash
1697 # directory has a space in it. See 93c3fcbe4d4 (git-svn: attempt to
1698 # mimic SVN 1.7 URL canonicalization, 2012-07-28) for prior art.
1699 test_uri_escape() {
1700 sed 's/ /%20/g'
1703 # Check that the given command was invoked as part of the
1704 # trace2-format trace on stdin.
1706 # test_subcommand [!] <command> <args>... < <trace>
1708 # For example, to look for an invocation of "git upload-pack
1709 # /path/to/repo"
1711 # GIT_TRACE2_EVENT=event.log git fetch ... &&
1712 # test_subcommand git upload-pack "$PATH" <event.log
1714 # If the first parameter passed is !, this instead checks that
1715 # the given command was not called.
1717 test_subcommand () {
1718 local negate=
1719 if test "$1" = "!"
1720 then
1721 negate=t
1722 shift
1725 local expr=$(printf '"%s",' "$@")
1726 expr="${expr%,}"
1728 if test -n "$negate"
1729 then
1730 ! grep "\[$expr\]"
1731 else
1732 grep "\[$expr\]"
1736 # Check that the given command was invoked as part of the
1737 # trace2-format trace on stdin.
1739 # test_region [!] <category> <label> git <command> <args>...
1741 # For example, to look for trace2_region_enter("index", "do_read_index", repo)
1742 # in an invocation of "git checkout HEAD~1", run
1744 # GIT_TRACE2_EVENT="$(pwd)/trace.txt" GIT_TRACE2_EVENT_NESTING=10 \
1745 # git checkout HEAD~1 &&
1746 # test_region index do_read_index <trace.txt
1748 # If the first parameter passed is !, this instead checks that
1749 # the given region was not entered.
1751 test_region () {
1752 local expect_exit=0
1753 if test "$1" = "!"
1754 then
1755 expect_exit=1
1756 shift
1759 grep -e '"region_enter".*"category":"'"$1"'","label":"'"$2"\" "$3"
1760 exitcode=$?
1762 if test $exitcode != $expect_exit
1763 then
1764 return 1
1767 grep -e '"region_leave".*"category":"'"$1"'","label":"'"$2"\" "$3"
1768 exitcode=$?
1770 if test $exitcode != $expect_exit
1771 then
1772 return 1
1775 return 0
1778 # Given a GIT_TRACE2_EVENT log over stdin, writes to stdout a list of URLs
1779 # sent to git-remote-https child processes.
1780 test_remote_https_urls() {
1781 grep -e '"event":"child_start".*"argv":\["git-remote-https",".*"\]' |
1782 sed -e 's/{"event":"child_start".*"argv":\["git-remote-https","//g' \
1783 -e 's/"\]}//g'
1786 # Print the destination of symlink(s) provided as arguments. Basically
1787 # the same as the readlink command, but it's not available everywhere.
1788 test_readlink () {
1789 perl -le 'print readlink($_) for @ARGV' "$@"
1792 # Set mtime to a fixed "magic" timestamp in mid February 2009, before we
1793 # run an operation that may or may not touch the file. If the file was
1794 # touched, its timestamp will not accidentally have such an old timestamp,
1795 # as long as your filesystem clock is reasonably correct. To verify the
1796 # timestamp, follow up with test_is_magic_mtime.
1798 # An optional increment to the magic timestamp may be specified as second
1799 # argument.
1800 test_set_magic_mtime () {
1801 local inc=${2:-0} &&
1802 local mtime=$((1234567890 + $inc)) &&
1803 test-tool chmtime =$mtime "$1" &&
1804 test_is_magic_mtime "$1" $inc
1807 # Test whether the given file has the "magic" mtime set. This is meant to
1808 # be used in combination with test_set_magic_mtime.
1810 # An optional increment to the magic timestamp may be specified as second
1811 # argument. Usually, this should be the same increment which was used for
1812 # the associated test_set_magic_mtime.
1813 test_is_magic_mtime () {
1814 local inc=${2:-0} &&
1815 local mtime=$((1234567890 + $inc)) &&
1816 echo $mtime >.git/test-mtime-expect &&
1817 test-tool chmtime --get "$1" >.git/test-mtime-actual &&
1818 test_cmp .git/test-mtime-expect .git/test-mtime-actual
1819 local ret=$?
1820 rm -f .git/test-mtime-expect
1821 rm -f .git/test-mtime-actual
1822 return $ret
1825 # Given two filenames, parse both using 'git config --list --file'
1826 # and compare the sorted output of those commands. Useful when
1827 # wanting to ignore whitespace differences and sorting concerns.
1828 test_cmp_config_output () {
1829 git config --list --file="$1" >config-expect &&
1830 git config --list --file="$2" >config-actual &&
1831 sort config-expect >sorted-expect &&
1832 sort config-actual >sorted-actual &&
1833 test_cmp sorted-expect sorted-actual
1836 # Given a filename, extract its trailing hash as a hex string
1837 test_trailing_hash () {
1838 local file="$1" &&
1839 tail -c $(test_oid rawsz) "$file" |
1840 test-tool hexdump |
1841 sed "s/ //g"